/***********************************************************
LGT
***********************************************************/
var hostString="";

function init() {
  this.loginData=["https://www.uplus.co.kr/idi/mbrm/info/ReqWbmbLgin.hpi","intgWbmbId","intgWbmbPwd"];
  this.pattern=/<errorCode>000000<\/errorCode>/;
  this.userMDN=null;
}
function process(aHttpChannel, aData){
  switch(this.stage){
  case ST_LOGIN_RES:  
    this.captcha=this.getForm(aData,"capcharCertFrm");
    if(this.captcha){
      var fnd=aData.match(/<img\s+name="capp".+?src="(\S+?)"/);        
      if(fnd){
        this.stage=ST_LOGIN_RES+3;
        this.getHtml("https://www.uplus.co.kr"+fnd[1]);
        return true;
      }
    }
  ++this.stage;
  case ST_LOGIN_RES+1:
    this.getHtml("http://www.uplus.co.kr/cpi/msmg/msms/RetrieveCpMsgMsSnd.hpi?mid=1767");
    return false;
  case ST_LOGIN_RES+2:
    var fnd=aData.match(/hpEziCon=(\S+?)&/);
    if(fnd){
      this.userKey="hpEziCon="+fnd[1];
      this.stage=ST_DATA;
      this.delay(1200);
      return true;
    }else break;
  case ST_LOGIN_RES+3:    
    var rs=this.main.openAuthDialog(this,1,this.user,null,aData);
    if(rs){
      this.stage=ST_LOGIN_RES+1;
      this.getHtml("https://www.uplus.co.kr/idi/mbrm/info/ReqWbmbLgin.hpi",this.captcha+"&inCapCharText="+rs);
      return true;
    }
    break;
  case ST_DATA:
    this.getHtml("http://msgmall.ez-i.co.kr/web/UserInfo.web",this.userKey);
    return false;
  }
  return this.baseProcess(aHttpChannel, aData);
}
function onSend(sender,receiver,msg){
  var msg_org=this.main.msg[0][M_MSG];
  var msg=encodeURIComponent(encodeURIComponent(msg_org));
  var post="productList=&albumInfo=&receiveList="+receiver
            +"&subject="+this.getSubject(msg_org)
            +"&sMessage="+msg+"&mMessage="+msg
            +"&msgGubun=SMS&msgSize="+this.getLength(msg_org)
            +"&reserveYn=N&reserveDate=&callbackCtn="+sender+"&tMessage=MCMall_WEB&oMessage="+msg
            +"&otpId=&priceInfo=0&";
  this.getHtml("http://msgmall.ez-i.co.kr/web/SendMsgReq.web",post);
  return false;
}
function getCount(aData){
  if(!this.userMDN){
    var fnd=aData.match(/<custCtn>(\d+)</);
    if(fnd){
      this.userMDN="0"+fnd[1];
      this.setSender(this.userMDN);
    }
  }
  var fnd=aData.match(/<loginYn>Y</);
  if(fnd){
    fnd=aData.match(/<freeSmsCnt>(\d+)</);
    if(fnd)return fnd[1];
  }
  return -1;
}

function getLength(str){
  var n=0;
  for(var i=0;i<str.length;i++){
    if(str.charCodeAt(i)<255)++n;
    else n+=2;
  }
  return n;
}
function getSubject(str){
  if(str.length>=10){
    var n=0;
    for(var i=0;i<str.length;i++){
      if(str.charCodeAt(i)<255)++n;
      else n+=2;
      if(n>19){
        str=str.substring(0,i);
        break;
      }
    }
  }
  return Components.classes["@mozilla.org/intl/texttosuburi;1"]
            .getService(Components.interfaces.nsITextToSubURI)
              .ConvertAndEscape("euc-kr", str);
}
